//################################
Lib.UTILS = {};


Lib.UTILS.percentOfBinA = function(a, b) {
    if (a === undefined || b === undefined)
        return 0;

    var percent = 0;
    percent = b / a;
    return percent;

}

Lib.UTILS.genUID = function() {
    function s4() {
        return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
    }
    return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
        s4() + '-' + s4() + s4() + s4();
};


//Rand Numbers. WARNING, max is included (0,10) could be 10
Lib.UTILS.randInt = function(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
};

Lib.UTILS.randFloat = function(min, max) {
    return Math.random() * (max - min) + min;
};



Lib.UTILS.fuzzyEqual = function(a, b) {
    return (Lib.UTILS.floatRoundTwoDec(a)) === (Lib.UTILS.floatRoundTwoDec(b));
}

Lib.UTILS.fuzzyLessThan = function(a, b) {

    return (Lib.UTILS.floatRoundTwoDec(a)) < (Lib.UTILS.floatRoundTwoDec(b));
}

Lib.UTILS.fuzzyGreaterThan = function(a, b) {

    return (Lib.UTILS.floatRoundTwoDec(a)) > (Lib.UTILS.floatRoundTwoDec(b));
}

Lib.UTILS.fuzzyLessOrEqualThan = function(a, b) {

    return (Lib.UTILS.floatRoundTwoDec(a)) <= (Lib.UTILS.floatRoundTwoDec(b));
}

Lib.UTILS.fuzzyGreaterOrEqualThan = function(a, b) {

    return (Lib.UTILS.floatRoundTwoDec(a)) >= (Lib.UTILS.floatRoundTwoDec(b));
}

Lib.UTILS.happens = function(chance) {
    var res = this.randFloat(0, 1);
    return this.fuzzyLessOrEqualThan(res, chance);
}

//USED BY ABOVE
Lib.UTILS.floatRoundTwoDec = function(val) {
    return Math.round(val * 100) / 100;
}

Lib.UTILS.radianToVec = function(radian) {
    var vec = new Phaser.Point();
    vec.x = Math.sin(radian);
    vec.y = -(Math.cos(radian));

    return vec;
}

Lib.UTILS.RGBtoHEX = function(r, g, b) {
    var bin = r << 16 | g << 8 | b;
    return (function(h) {
        return new Array(7 - h.length).join("0") + h
    })(bin.toString(16).toUpperCase())
}

Lib.UTILS.HEXtoRGB = function(hex) {
    var r = hex >> 16;
    var g = hex >> 8 & 0xFF;
    var b = hex & 0xFF;
    return [r, g, b];
}

//return normalized direction between two sets of coords
Lib.UTILS.directionBetweenAB = function(pointA, pointB) {
    direction = new Phaser.Point(pointA.x - pointB.x, pointA.y - pointB.y);
    return direction.normalize();
}

//a point is defined by position and direction
//returns a point along the lide based on distance
Lib.UTILS.pointAlongLine = function(pointA, direction, distance) {
    return new Phaser.Point(pointA.x + direction.x * distance, pointA.y + direction.y * distance);
}

Lib.UTILS.distanceBetweenAB = function(pointA, pointB) {
    return Phaser.Math.distance(pointA.x, pointA.y, pointB.x, pointB.y);
}

//returns a rand point of startpoint + magnitude
Lib.UTILS.getRandPointWithMagnitude = function(startPointX, startPointY, distance) {
    // p("Called ");
    //direction of new point + magnituted
    var randDir = new Phaser.Point(Lib.UTILS.randFloat(-1, 1), Lib.UTILS.randFloat(-1, 1));
    if (randDir.x === 0) {
        randDir.x = 0.1;
    }
    if (randDir.y === 0) {
        randDir.y = 0.1;
    }
    randDir.setMagnitude(distance);
    // p("Rand DIr is " + randDir);
    // p("original point is " + startPoint);
    //add start point
    randDir.add(startPointX, startPointY);

    // p("New point is " + randDir);
    return randDir;

}


//returns a point C along A and b starting from A that goes a distance
Lib.UTILS.pointAlongAB = function(pointA, pointB, distance) {
    var direction = Lib.UTILS.directionBetweenAB(pointA, pointB);
    var pointC = Lib.UTILS.pointAlongLine(pointA, direction, distance);
    return pointC;
}

//point along the line AB that goes towards B
Lib.UTILS.pointTowardsB = function(pointA, pointB, distance) {
    //negate distance if conditions
    if (pointA.y < pointB.y || pointA.x < pointB.x || pointA.x > pointB.x || pointA.y > pointB.y) {
        distance = -distance;
    }
    var pointC = Lib.UTILS.pointAlongAB(pointA, pointB, distance);
    return pointC;
}


Lib.UTILS.cleanArrayFromUndefined = function(elements) {
    if (elements === undefined) {
        console.warn("PASSED UNDEFINED ELEMENTS TO CLEAN UNDEFINED");
        return 0;
    }
    var newElements = [];
    var undefinedFound = 0;
    for (var i = 0; i < elements.length; i++) {
        if (elements[i] !== undefined) {
            newElements.push(elements[i]);
        }
        else {
            undefinedFound++;
        }
    }
    console.log("Found UNDEFINED " + undefinedFound);
    // return newElements;
    elements = newElements;
}

Lib.UTILS.centerAnchorX = function(obj) {
    var newX = game.width / 2;
    obj.x = newX;
}

Lib.UTILS.centerAnchorY = function(obj) {
    var newY = game.height / 2;
    obj.y = newY;
}

Lib.UTILS.createDummyObj = function(propArray) {
    if (!Lib.check.isArray(propArray) || propArray.length === 0) {
        Lib.glob.warn("property array is empty or undefined. creating empty obj");
        return {};
    }
    else {
        var obj = {};
        for (var a = 0; a < propArray.length; a++) {
            var prop = propArray[a];
            prop = Lib.check.exists(prop) ? prop.toString() : undefined;
            if (!Lib.check.isString(prop) || Lib.check.isEmptyString(prop)) {
                Lib.glob.warn("Cant convert property to string. Returning object with created properties until now.")
                return obj;
            }

            obj[prop] = 0;
        }
    }

    return obj;
}

Lib.UTILS.DELTA_TIME = function() {
    return game.time.elapsed / 1000;
}

//check an array of objects for a val an return obj. Return empty obj if not found
Lib.UTILS.getObjFromArrByVal = function(arr, val) {
    if (Lib.check.totalArrCheck(arr, "object") && Lib.check.exists(val)) {
        for (var a = 0; a < arr.length; a++) {
            var obj = arr[a];
            for (var prop in obj) {
                if (Lib.check.objHasProps(obj, [prop]) && obj[prop] === val) {
                    return obj;
                }
            }
        }
    }
    return {};
}

Lib.UTILS.getRandValFromArr = function(arr){
    if(!Lib.check.isEmptyArray(arr)){
        var index = Lib.UTILS.randInt(0,arr.length-1);
        return arr[index];
    }
}


Lib.UTILS.shuffleArr = function(array) {
    for (var i = array.length - 1; i > 0; i--) {
        var j = Math.floor(Math.random() * (i + 1));
        var temp = array[i];
        array[i] = array[j];
        array[j] = temp;
    }
    return array;

}

//Create image in a group. If group is undefined create without group
Lib.UTILS.createImageInGroup = function(x, y, texture, group) {
    var obj = undefined;
    if (Lib.check.objHasMethod(group, "create")) {
        obj = group.create(x, y, texture);
    }
    else {
        obj = game.add.image(x, y, texture);
    }
    return obj;
}

//Create sprite in a group. If group is undefined create without group.
//Group classType should be set beforehand to Sprite, otherwise it will create just an image
Lib.UTILS.createSpriteInGroup = function(x, y, texture, group) {
    var obj = undefined;
    if (Lib.check.objHasMethod(group, "create")) {
        obj = group.create(x, y, texture);
    }
    else {
        obj = game.add.sprite(x, y, texture);
    }
    return obj;
}


//Create an emitter. Add it to group if group exists.
Lib.UTILS.createEmitterInGroup = function(x, y, maxParticles, group) {
    var obj = game.add.emitter(x, y, maxParticles);
    if (Lib.check.objHasMethod(group, "create")) {
        p("IN GROUP");
        group.add(obj);
    }
    return obj;
}

//Create a text object. add it to the group if exists
Lib.UTILS.createTextInGroup = function(x,y,text,style,group){
    var obj = game.add.text(x,y,text,style);
    
    if (Lib.check.objHasMethod(group, "create")) {
        group.add(obj);
    }
    return obj;

}

//create a button in group 
Lib.UTILS.createButtonInGroup = function(x,y,texture,callback,context, group){
    var obj = game.add.button(x,y,texture,callback,context);

    if (Lib.check.objHasMethod(group, "create")) {
        group.add(obj);
    }
    return obj;
}